#Pour que le programme marche, il faut rajouter les variables d'environnement suivantes à votre système:
#SPOTIPY_CLIENT_ID
#SPOTIPY_CLIENT_SECRET
#SPOTIPY_REDIRECT_URI
#Pour les obtenir, il faut créer une application sur le site de spotify => https://developer.spotify.com/dashboard/applications

#Imports
from signal import SIGTERM
import time,string,random,spotipy
from tkinter import UNDERLINE
from spotipy.oauth2 import SpotifyOAuth
from random import randrange
from pynput import keyboard

#Couleurs
Red = '\033[91m'
Green = '\033[92m'
Blue = '\033[94m'
Cyan = '\033[96m'
White = '\033[97m'
Yellow = '\033[93m'
Magenta = '\033[95m'
Grey = '\033[90m'
Black = '\033[90m'
Default = '\033[99m'
UNDERLINE = '\033[4m'
NORMAL = '\033[0m'

#Variables globales
DIV_TEMPS=200
POPULARITY_THRESHOLD=70
RANDOMNESS=32
ADJUST=0
QUIT_SIGNAL=0
SKIP_SIGNAL=1
TEMPS_M=0
LISTE_URIS=[]

#Raccourcis clavier
def on_press(key):
    global ADJUST, QUIT_SIGNAL, SKIP_SIGNAL,TEMPS_M
    try:
        if(key.char=="+"):
            TEMPS_M+=300
        if(key.char=="-"):
            TEMPS_M-=300
    except AttributeError:
        if(format(key)=="Key.f12"):
            QUIT_SIGNAL=1
        if(format(key)=="Key.f2"):
            SKIP_SIGNAL=1
        pass#print('special key {0} pressed'.format(key))

listener = keyboard.Listener(
    on_press=on_press,)
listener.start()

#Authentification et portée de l'application
scope = "streaming,user-read-playback-state"
sp = spotipy.Spotify(auth_manager=SpotifyOAuth(scope=scope))

#Application continue
while(1):
    FT=0  #found track var
    while(FT==0):
        #recherche un artiste avec une lettre aléatoire et avec un index aléatoire
        try:
            RAND_ART=sp.search(random.choice(string.ascii_letters),limit=1,offset=randrange(RANDOMNESS),type="artist")
        except:
            print(Red+"Err : Artiste inexistant")
        else:
            #teste la popularité de son meilleur morceau
            print('\n'+'\033[95m'+ RAND_ART['artists']['items'][0]['name'] +NORMAL, end = '')
            TT = sp.artist_top_tracks(RAND_ART['artists']['items'][0]['uri'],'FR')
            print('\033[91m'+White+" - "+Cyan+TT['tracks'][0]['name']+White,end="")
            if(TT['tracks'][0]['uri'] in LISTE_URIS):
                print(Red+" 🔃 Doublons")
            else:
                if(TT['tracks'][0]['popularity']>=POPULARITY_THRESHOLD):
                    FT=1
                    print(Green,end="")
                else:
                    print(Red,end="")
                print(" ➤ "+str(TT['tracks'][0]['popularity'])+"%")

    #Reset variables
    ML=0
    SKIP_SIGNAL=0
    TIME=0

    while(ML==0):
        try:
            #Joue le morceau sur l'appareil en cours de lecture
            LISTE=[]
            LISTE.append(TT['tracks'][0]['uri'])
            sp.start_playback(uris=LISTE)
        except:
            print(Red+"[❔] Aucun appareil spotify trouvé...(nouvelle tentative dans 10s)")
            time.sleep(10)
        else:       
            #log uris
            LISTE_URIS.append(TT['tracks'][0]['uri'])

            DEV=sp.current_playback()
            TEMPS_M=round(TT['tracks'][0]['duration_ms']/DIV_TEMPS,0)
            ML=1
            while(TIME<TEMPS_M):
                print('\r'+White+'╚══╡'+str(round(100*(TIME/TEMPS_M),1))+'%╞═══╡En écoute sur : ' +Yellow+ DEV['device']['name'],end='')
                if(QUIT_SIGNAL==1):
                    quit()
                if(SKIP_SIGNAL==1):
                    break
                time.sleep(0.1)
                TIME+=1

#TODO
#creer liste URI pour eviter doublon (clean a chaque demarrage)
#Whitelist/blacklist genre